<!DOCTYPE html>
<html>
<head>
  <meta charset="utf-8" name="viewport" content="width=device-width, initial-scale=1">
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/6.4.0/css/all.min.css">
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
  <!-- Import DataTable Library -->
  
  <link rel="stylesheet" href="https://cdn.datatables.net/1.13.4/css/jquery.dataTables.min.css">
  <script src="https://cdn.datatables.net/1.13.4/js/jquery.dataTables.min.js"></script>
</head>

<body>
  <div class="container">
    <div class="text-center mt-4 mb-3">
      <h2>F100 - QUẢN TRỊ NGƯỜI DÙNG</h2>
    </div>
    <div class="jumbotron container">
      <div class="row form-group mb-0">
        <div class="col-sm-3">
          <label for="voucherCodeInput">Role</label>
        </div>
        <div class="col-sm-6">
          <select id="roleSelect" class="form-control"></select>
        </div>
        <div class="col-sm-3">
          <button id="btn-filter-role" class="btn btn-info">Lọc dữ liệu</button>
        </div>
      </div>
    </div>
    <table id="user-table" class="table table-bordered table-striped table-hover">
      <thead class="thead-dark">
        <tr>
          <th scope='col'>STT</th>
          <th scope='col'>Username</th>
          <th scope='col'>First name</th>
          <th scope='col'>Last name</th>
          <th scope='col'>Email</th>
          <th scope='col'>Age</th>
          <th scope='col'>Role</th>
          <th scope='col'>Action</th>
        </tr>
      </thead>
      <tbody>
      </tbody>
    </table>
  </div>
<script>
  /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
  // Mảng gUserObjects là mảng chứa dữ liệu users
  var gUserObjects = [
        {
          id: 2,
          username: "quannv",
          firstname: "Ngo Van",
          lastname: "Quan",
          age: 18,
          email: "quan@gmail.com",
          roleId: 5
        },
        {
          id: 3,
          username: "longdh",
          firstname: "Do Hoang",
          lastname: "Long",
          age: 19,
          email: "long@gmail.com",
          roleId: 8
        },
        {
          id: 4,
          username: "hiendt",
          firstname: "Do Thi",
          lastname: "Hien",
          age: 29,
          email: "hien@gmail.com",
          roleId: 11
        },
        {
          id: 6,
          username: "lanht",
          firstname: "Ho Thi",
          lastname: "Lan",
          age: 27,
          email: "lan@gmail.com",
          roleId: 13
        }
  ];
  // Mảng gRoleObjects là mảng chứa dữ liệu các roles
  var gRoleObjects = [
        {
          roleId: 5,
          roleName: "Admin" 
        },
        {
          roleId: 8,
          roleName: "Manager" 
        },
        {
          roleId: 11,
          roleName: "Teacher" 
        },
        {
          roleId: 13,
          roleName: "Staff" 
        }
  ];

  const gARRAY_NAME_COL = ['id', 'username', 'firstname', 'lastname', 'age',  'email', 'roleId', 'action'];
  const gCOL_ID = 0;
  const gCOL_USER_NAME = 1;
  const gCOL_FIRST_NAME = 2;
  const gCOL_LAST_NAME = 3;
  const gCOL_AGE = 4;
  const gCOL_EMAIL = 5;
  const gCOL_ROLE_ID = 6;
  const gCOL_ACTION = 7;

  var gSTT = 1;
  /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
  onPageLoading();
  $("#btn-filter-role").on("click", function(){
    onBtnFilterClick();
  });
  $("#user-table").on("click",".fa-dice", function(){
    onBtnDiceHistoryClick();
  })
  /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */  
  function onPageLoading(){
    "use strict";
    $("#user-table").DataTable({
        data: gUserObjects,
        columns: [
            { data: gARRAY_NAME_COL[gCOL_ID] },
            { data: gARRAY_NAME_COL[gCOL_USER_NAME] },
            { data: gARRAY_NAME_COL[gCOL_FIRST_NAME] },
            { data: gARRAY_NAME_COL[gCOL_LAST_NAME] },
            { data: gARRAY_NAME_COL[gCOL_AGE] },
            { data: gARRAY_NAME_COL[gCOL_EMAIL] },
            { data: gARRAY_NAME_COL[gCOL_ROLE_ID] },
            { data: gARRAY_NAME_COL[gCOL_ACTION] }
        ],
        columnDefs: [{
          targets: gCOL_ID,
          render: function(data){
            return gSTT++;
          }
        },
        {
          targets: gCOL_ACTION,
          defaultContent: '<i title="Dice" class="fa-solid fa-dice" style="cursor: pointer; color:green;">&nbsp;</i><i title="Gift" class="fa-sharp fa-solid fa-gift" style="cursor: pointer; color:green;"></i>'
        }
      ]
    });
    loadDataToSelect(gRoleObjects);
  }
  function onBtnFilterClick(){
    "use strict";
    var vFilterObj = {
      roleIdObj : 0,
    };
    getDataSelected(vFilterObj);
    console.log(vFilterObj);
    var vValid = filterData(vFilterObj);
    console.log(vValid);
    displayDataToTable(vValid);
  }
  function onBtnDiceHistoryClick(paramDataRow){
    const vDETAIL_FOR_URL = "task 38.30.html";
    var vUrlSiteToOpen = vDETAIL_FOR_URL + "?user_name=" + paramDataRow.username + "&first_name=" + paramDataRow.firstname + "&last_name=" + paramDataRow.lastname;
    location.href = vUrlSiteToOpen;
  }
  /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
  function loadDataToSelect(paramData){
  "use strict";
  $("#roleSelect").append($("<option>",{
    value: 0,
    text: '--Select Role--'
  }));
  for(var bI=0; bI<paramData.length; bI++){
    $("#roleSelect").append($("<option>",{
    value: paramData[bI].roleId,
    text: paramData[bI].roleName
  }));
  }
}
function getDataSelected(paramObj){
  paramObj.roleIdObj = $("#roleSelect").val();
}
function filterData(paramData){
  //debugger;
  var vResult = [];
  vResult = gUserObjects.filter(function(item){
    return (item.roleId == paramData.roleIdObj || paramData.roleIdObj == 0);
  })
  return vResult;
}
function displayDataToTable(paramData){
  gSTT = 1;
  var vTable = $("#user-table").DataTable();
  vTable.clear();
  vTable.rows.add(paramData);
  vTable.draw();
}
</script>
</body>
</html>